<?php
/*
Plugin Name: Version Information
Plugin URI: http://www.basilv.com/psd/software
Description: Displays version information for PHP, MySQL, WordPress, and the web server. A summary is displayed on the dashboard and more details are displayed under Plugins | Version Information.
Version: 1.0
Author: Basil Vandegriend
Author URI: http://www.basilv.com/psd/
License: GPL version 3.0 or later (http://www.gnu.org/copyleft/gpl.html).
*/

// Copyright 2007 by Basil Vandegriend.

function version_info_summary_table() {
	global $wpdb;
?>
	<table>
		<tr>
		<td align="right">WordPress:</td>
		<td><?php bloginfo('version'); ?></td>
		</tr>
		<tr>
		<td align="right">MySQL:</td>
		<td><?php print($wpdb->get_var('SELECT VERSION()')); ?></td>
		</tr>
		<tr>
		<td align="right">PHP:</td>
		<td><?php print(phpversion()); ?></td>
		</tr>
		<tr>
		<td align="right">Server:</td>
		<td><?php print($_SERVER['SERVER_SOFTWARE']); ?></td>
		</tr>
	</table>
<?php
}

function version_info_summary() {
?>
	<h3>Version Information</h3>
	<p>
	<?php version_info_summary_table(); ?>
	</p>
<?php
}

function version_info_page() {
?>
	<div style="width:75%;" class="wrap" id="VersionInfoDiv">

	<h2>Version Information</h2>
	<h3>Summary</h3>
	<p>
	<?php version_info_summary_table(); ?>
	</p>
	
	<h3>PHP Configuration Information</h3>
	<p>
		<?php
		/*  phpinfo() by itself has embedded styles that clash with WordPress. 
			Therefore we embedded phpinfo in its own <div> and customize all the styles 
			to only apply within this div. 
			Thanks to http://ca3.php.net/manual/en/function.phpinfo.php#77705 for this.		
		*/
		ob_start();
		phpinfo(INFO_GENERAL);
		
		preg_match ('%<style type="text/css">(.*?)</style>.*?(<body>.*</body>)%s', ob_get_clean(), $matches);

		$styleHtml=$matches[1];
		$bodyHtml=$matches[2];		
		
		echo "<div class='phpinfodisplay'>",
			"<style type='text/css'>\n",
			// Convert each style to apply only within the phpinfodisplay class.
		    join( "\n", array_map(
	            create_function(
	                '$i',
	                'return ".phpinfodisplay " . preg_replace( "/,/", ",.phpinfodisplay ", $i );'
	                ),
	            preg_split( '/\n/', $styleHtml )
	         ) ),
	    	"</style>\n",
		    $bodyHtml,
		    "\n</div>\n";
		?>		
	</p>
	 
	</div>
<?php
}

function version_info_init() {
	if ( function_exists('add_submenu_page') ) {
		add_submenu_page('plugins.php', 'Version Information', 'Version Information', 1, basename(__FILE__), 'version_info_page');
	}
}

add_action('admin_menu', 'version_info_init');
add_action('activity_box_end', 'version_info_summary');
?>